/*  Autor: Leandro Bernsmuller
Declara dadosfis.cpp */



class CDadosFisicos : public CDados {

public:

   CDadosFisicos ();
   ~CDadosFisicos ();
   
   DWORD m_dwGrupo;          // grupo do objeto
   DWORD m_dwNdxObjeto;      // identificador do objeto que eh seu "corpo"
   DWORD m_dwTempoUltimaDir; // quando foi a ultima mudanca de direcao

   // definicao de comportamento
   float m_fFome;            // nivel de fome (quanto maior, mais fome)
   BYTE  m_yComposicao;      // qual a composicao do corpo (carne/vegetal,...)
   DWORD m_dwTipoCorpo;      // qual o modelo usado como corpo
   float m_fRelogioBiologico;// o relogio biologico do agente
   int m_nFreqReproducao;    // Frequencia de reproducao (de acordo com
                             // relogio biologico).
   
   float m_fLocalReproduzX;  // Coordenadas do local tipico de reproducao
   float m_fLocalReproduzY;  // x, y, z no SRU (sao nestas proximidades
   float m_fLocalReproduzZ;  // que os novos nascem).

   float m_fPerdeReproduzindo; // quanto perde ao se reproduzir
};
