/* Autor: Leandro Bernsmuller
Declara jancen.cpp */



class CJanelaCenario : public CJanela {

public:

   // possui a definicao de um cenario para uma janela
   struct tagInfoCenario {
      CCenarioFisico* poCenario;    // aponta o cenario
      float fPropXIni;        // Proporcoes para localizacao
      float fPropXFim;        // do cenario na janela, relativo
      float fPropYIni;        // aos limites direito/esquerdo,
      float fPropYFim;        // superior/inferior.
   };

   // cenario da janela
   tagInfoCenario m_pstCenario;

   BOOL mCria ( DWORD dwMenu, char* szTitulo, HINSTANCE hInstance );
   void mDestroi ();
   void mProcessaCenario ( BOOL bMover );
   void mIncluiCenario ( float fPropXIni, float fPropYIni,
                         float fPropXFim, float fPropYFim, CCenarioFisico& oCen );
   void mRedesenha ();

   // tratam mensagens do Windows
   BOOL mTrataMensagensWindows ( HWND& hWnd, UINT& uMsg, WPARAM& wParam,
                                 LPARAM& lParam );
   void mWinAlteraVideo ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
   void mWinAlteraTamanhoJanela ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
   void mWinAtivo ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
   BOOL mWinPintar ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
};
